// MgaAttribute.h : Declaration of the CMgaAttribute

#ifndef __MGAATTRIBUTE_H_
#define __MGAATTRIBUTE_H_

#include "resource.h"       // main symbols



/////////////////////////////////////////////////////////////////////////////
// CMgaAttribute
//##ModelId=3C5AA09B0344
class ATL_NO_VTABLE CMgaAttribute : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CMgaAttribute, &CLSID_MgaAttribute>,
	public IDispatchImpl<IMgaAttribute, &IID_IMgaAttribute, &LIBID_MGALib>,
	public ISupportErrorInfoImpl<&IID_IMgaAttribute>
{
public:
	//##ModelId=3C5AA09C0042
	CMgaAttribute()	: prevptr(NULL), next(NULL), load_status(ATTSTATUS_INVALID) {	}

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMgaAttribute)
	COM_INTERFACE_ENTRY(IMgaAttribute)
	COM_INTERFACE_ENTRY_IID(IID_ISupportErrorInfo, IMyErrorInfoBase)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IMgaAttribute
public:
	//##ModelId=3C5AA09C0043
	STDMETHOD(get_Meta)( IMgaMetaAttribute **pVal) {
		COMTRY {
				CHECK_OUTPTRPAR(pVal);
				CComQIPtr<IMgaMetaAttribute> m(mgaproject->FindMetaRef(mref));
				*pVal = m.Detach();
		} COMCATCH(;)
	}
	//##ModelId=3C5AA09C0056
	STDMETHOD(get_Owner)( IMgaFCO **pVal);
	//##ModelId=3C5AA09C0060
	STDMETHOD(get_Status)( long *status);
	//##ModelId=3C5AA09C006D
	STDMETHOD(get_Value)( VARIANT *pVal);
	//##ModelId=3C5AA09C007F
	STDMETHOD(put_Value)( VARIANT newVal);

	//##ModelId=3C5AA09C0089
	STDMETHOD(get_StringValue)(BSTR *pVal);
	//##ModelId=3C5AA09C0095
	STDMETHOD(put_StringValue)( BSTR newVal);
	//##ModelId=3C5AA09C00A7
	STDMETHOD(get_OrigValue)( VARIANT *pVal);
	//##ModelId=3C5AA09C00B1
	STDMETHOD(get_HasChanged)( VARIANT_BOOL *pVal);

	//##ModelId=3C5AA09C00BC
	STDMETHOD(get_IntValue)( long *pVal);
	//##ModelId=3C5AA09C00CF
	STDMETHOD(put_IntValue)( long newVal);
	//##ModelId=3C5AA09C00D9
	STDMETHOD(get_BoolValue)( VARIANT_BOOL *pVal);
	//##ModelId=3C5AA09C00E4
	STDMETHOD(put_BoolValue)( VARIANT_BOOL newVal);
	//##ModelId=3C5AA09C00F7
	STDMETHOD(get_FloatValue)( double *pVal);
	//##ModelId=3C5AA09C0101
	STDMETHOD(put_FloatValue)( double newVal);
	//##ModelId=3C5AA09C010C
	STDMETHOD(get_FCOValue)( IMgaFCO **pVal);
	//##ModelId=3C5AA09C0117
	STDMETHOD(put_FCOValue)( IMgaFCO * newVal);

	//##ModelId=3C5AA09C0129
	STDMETHOD(get_RegistryNode)( BSTR path,  IMgaRegNode **pVal); 
	//##ModelId=3C5AA09C0134
	STDMETHOD(get_Registry)(VARIANT_BOOL virtuals, IMgaRegNodes **pVal);
	//##ModelId=3C5AA09C0148
	STDMETHOD(get_RegistryValue)( BSTR path,  BSTR *pVal);
	//##ModelId=3C5AA09C015B
	STDMETHOD(put_RegistryValue)( BSTR path,  BSTR newval);

	//##ModelId=3C5AA09C0167
	STDMETHOD(Clear)();

	//##ModelId=3C5AA09C0205
	typedef CMgaAttribute *hashobp;
	hashobp *prevptr, next;
	//##ModelId=3C5AA09C0170
	~CMgaAttribute() {						// remove object from hash
		if(next) next->prevptr = prevptr;
		*prevptr = next;
	}
	//##ModelId=3C5AA09C0179
	void Initialize(metaref_type mr, FCO *o, CMgaProject *p);   // Throws!!!
	//##ModelId=3C5AA09C018E
	metaref_type mref;

	//##ModelId=3C5AA09C0197
	long load_status;
	//##ModelId=3C5AA09C01AC
	CoreObj valueobj;
	//##ModelId=3C5AA09C01C0
	CComQIPtr<IMgaMetaAttribute> mvalueobj;
	//##ModelId=3C5AA09C01CA
	FCOPtr fco;
	attval_enum attrtyp, inputtyp;
	//##ModelId=3C5AA09C01DE
	CMgaProject *mgaproject;
	//##ModelId=3C5AA09C01F2
	CComBSTR(regprefix);
};


#define APOOL_HASHSIZE 8
#define apool_hash(x) ((x)%APOOL_HASHSIZE)


//##ModelId=3C5AA09C0237
class attrpool {
	//##ModelId=3C5AA09C024C
	CMgaAttribute::hashobp pool[APOOL_HASHSIZE];
public:
	//##ModelId=3C5AA09C025F
	attrpool() { 
		int i; 
		for(i = 0; i < APOOL_HASHSIZE;i++) pool[i] = NULL;
	}

	//##ModelId=3C5AA09C0260
	~attrpool() {
		int i; 
		for(i = 0; i < APOOL_HASHSIZE;i++) ASSERT(pool[i] == NULL);
	}

	// Throws (allocates)!!!!
	//##ModelId=3C5AA09C0261
	CComPtr<IMgaAttribute> getpoolobj(metaref_type mref, FCO *o, CMgaProject *pr) {
		CMgaAttribute::hashobp &k = pool[apool_hash(mref)], *kk;
		for(kk = &k; *kk != NULL; kk = &((*kk)->next)) {
			if((*kk)->mref == mref) {
				return (*kk);
			}
		}
		CComPtr<CMgaAttribute> s;
		CreateComObject(s);
		s->prevptr = &k;				// Insert to the front
		s->next = k;
		if(k) k->prevptr = &(s->next);
		k = s;

		s->Initialize(mref, o, pr);  
		return s;
	}
};

void MergeAttrs(const CoreObj &src, CoreObj &dst);


/////////////////////////////////////////////////////////////////////////////
// CMgaRegNode
//##ModelId=3C5AA09C0378
class ATL_NO_VTABLE CMgaRegNode : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CMgaRegNode, &CLSID_MgaRegNode>,
	public IDispatchImpl<IMgaRegNode, &IID_IMgaRegNode, &LIBID_MGALib>,
	public ISupportErrorInfoImpl<&IID_IMgaRegNode>
{
public:

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMgaRegNode)
	COM_INTERFACE_ENTRY(IMgaRegNode)
	COM_INTERFACE_ENTRY_IID(IID_ISupportErrorInfo, IMyErrorInfoBase)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IMgaRegNode
	//##ModelId=3C5AA09D0080
	void markchg();
public:
	//##ModelId=3C5AA09D0081
	STDMETHOD(get_Name)( BSTR *pVal) { 
		COMTRY {
			CHECK_OUTPAR(pVal);
			LPCOLESTR p = wcsrchr(mypath, '/');
			if(p) p += 1; // skip '/'
			else p = mypath;
			CComBSTR rval(p);
			*pVal = rval.Detach();
		} COMCATCH(;); 
	};
	//##ModelId=3C5AA09D0094
	STDMETHOD(get_Path)( BSTR *pVal) { 
		COMTRY {
			CHECK_OUTPAR(pVal);
			*pVal = mypath.Copy();
		} COMCATCH(;); 
	};
	//##ModelId=3C5AA09D009E
	STDMETHOD(get_Object)( IMgaObject **pVal);
	//##ModelId=3C5AA09D00A8
	STDMETHOD(get_Value)( BSTR *pVal);
	//##ModelId=3C5AA09D00B3
	STDMETHOD(put_Value)( BSTR newVal);
	//##ModelId=3C5AA09D00BE
	STDMETHOD(get_FCOValue)( IMgaFCO **pVal);
	//##ModelId=3C5AA09D00D0
	STDMETHOD(put_FCOValue)( IMgaFCO *newVal);
	//##ModelId=3C5AA09D00DA
	STDMETHOD(get_SubNodes)( VARIANT_BOOL virtuals, IMgaRegNodes **pVal);
	//##ModelId=3C5AA09D00F8
	STDMETHOD(get_SubNodeByName)(BSTR name, IMgaRegNode **pVal);
	//##ModelId=3C5AA09D0103
	STDMETHOD(get_ParentNode)( IMgaRegNode **pVal);

	//##ModelId=3C5AA09D010E
	STDMETHOD(get_Status)( long *status);
	//##ModelId=3C5AA09D0120
	STDMETHOD(get_Opacity)( VARIANT_BOOL *pVal);
	//##ModelId=3C5AA09D012A
	STDMETHOD(put_Opacity)( VARIANT_BOOL newVal);
	//##ModelId=3C5AA09D0135
	STDMETHOD(Clear)();
	//##ModelId=3C5AA09D013F
	STDMETHOD(RemoveTree)();

	//##ModelId=3C5AA09D01C0
	typedef CMgaRegNode *hashobp;
	hashobp *prevptr, next;
	//##ModelId=3C5AA09D0148
	CMgaRegNode()	: prevptr(NULL), next(NULL), load_status(ATTSTATUS_INVALID) {	}
	//##ModelId=3C5AA09D0149
	~CMgaRegNode() {						// remove object from hash
		if(next) next->prevptr = prevptr;
		*prevptr = next;
	}
	//##ModelId=3C5AA09D0152
	void Initialize(BSTR path, FCO *o, CMgaProject *p) {   // Throws!!!
		mypath = path;		
		fco = o;
		mgaproject = p;
	}

	//##ModelId=3C5AA09D0166
	long load_status;
	//##ModelId=3C5AA09D0171
	CoreObj valueobj;
	//##ModelId=3C5AA09D0185
	FCOPtr fco;
	//##ModelId=3C5AA09D018F
	CComBSTR mypath;
	//##ModelId=3C5AA09D01A3
	CMgaProject *mgaproject;
};


#define RPOOL_HASHSIZE 8


//##ModelId=3C5AA09D01F3
class regnpool {
	//##ModelId=3C5AA09D0208
	CMgaRegNode::hashobp pool[RPOOL_HASHSIZE];
public:
	//##ModelId=3C5AA09D021B
	regnpool() { 
		int i; 
		for(i = 0; i < RPOOL_HASHSIZE;i++) pool[i] = NULL;
	}

	//##ModelId=3C5AA09D021C
	~regnpool() {
		int i; 
		for(i = 0; i < RPOOL_HASHSIZE;i++) ASSERT(pool[i] == NULL);
	}

	//##ModelId=3C5AA09D021D
	int rpool_hash(BSTR nam) {
		int i = SysStringLen(nam);
		int hash = i;
		while(i) hash ^= nam[--i];
		return hash % RPOOL_HASHSIZE;
	}

	// Throws (allocates)!!!!
	//##ModelId=3C5AA09D022F
	CComPtr<IMgaRegNode>  getpoolobj(BSTR nam, FCO *o, CMgaProject *pr) {
		CMgaRegNode::hashobp &k = pool[rpool_hash(nam)], *kk;
		for(kk = &k; *kk != NULL; kk = &((*kk)->next)) {
			if((*kk)->mypath == nam) {
				return (*kk);
			}
		}
		CComPtr<CMgaRegNode > s;
		CreateComObject(s);
		s->prevptr = &k;				// Insert to the front
		s->next = k;
		if(k) k->prevptr = &(s->next);
		k = s;

		s->Initialize(nam, o, pr);  
		return s;
	}
};

void RegistryChildrenRemove(CoreObj &t);
void MergeRegs(const CoreObj &src, CoreObj &dst);



/////////////////////////////////////////////////////////////
// CMgaPart
/////////////////////////////////////////////////////////////

//##ModelId=3C5AA09D0347
class ATL_NO_VTABLE CMgaPart : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CMgaPart, &CLSID_MgaPart>,
	public IDispatchImpl<IMgaPart, &IID_IMgaPart, &LIBID_MGALib>,
	public ISupportErrorInfoImpl<&IID_IMgaPart>
{
public:

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMgaPart)
	COM_INTERFACE_ENTRY(IMgaPart)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IID(IID_ISupportErrorInfo, IMyErrorInfoBase)
END_COM_MAP()

// IMgaPart
public:
	//##ModelId=3C5AA09E0059
	STDMETHOD(get_Model)(struct IMgaModel **pVal );
	//##ModelId=3C5AA09E0064
	STDMETHOD(get_Meta)(struct IMgaMetaPart **pVal );
	//##ModelId=3C5AA09E006F
	STDMETHOD(get_MetaAspect)(struct IMgaMetaAspect **pVal );
	//##ModelId=3C5AA09E0079
	STDMETHOD(get_MetaRole)(struct IMgaMetaRole **pVal );
	//##ModelId=3C5AA09E008B
	STDMETHOD(get_FCO)(struct IMgaFCO **pVal);
	//##ModelId=3C5AA09E0095
	STDMETHOD(get_AccessMask)(long *);

	//##ModelId=3C5AA09E00A0
	STDMETHOD(GetGmeAttrs)(BSTR *icon,long *x,long *y);
	//##ModelId=3C5AA09E00B4
	STDMETHOD(SetGmeAttrs)(BSTR icon,long x,long y);

	//##ModelId=3C5AA09E00C9
	STDMETHOD(get_RegistryMode)( VARIANT_BOOL *own);
	//##ModelId=3C5AA09E00D4
	STDMETHOD(put_RegistryMode)( VARIANT_BOOL own);

	//##ModelId=3C5AA09E00E6
	STDMETHOD(get_RegistryNode)( BSTR path,  IMgaRegNode **pVal);
	//##ModelId=3C5AA09E00F1
	STDMETHOD(get_Registry)( VARIANT_BOOL virtuals, IMgaRegNodes **pVal);
	//##ModelId=3C5AA09E0104
	STDMETHOD(get_RegistryValue)( BSTR path,  BSTR *pVal);
	//##ModelId=3C5AA09E0118
	STDMETHOD(put_RegistryValue)( BSTR path,  BSTR newval);  
	//##ModelId=3C5AA09E0123
	CMgaPart();
	//##ModelId=3C5AA09E012C
	~CMgaPart();
	//##ModelId=3C5AA09E012D
	void Initialize(metaref_type mr, FCO *o, CMgaProject *p);
	//##ModelId=3C5AA09E01AE
	typedef CMgaPart *hashobp;
	hashobp *prevptr, next;
	//##ModelId=3C5AA09E0141
	metaref_type mref;

	//##ModelId=3C5AA09E014A
	long load_status;
	//##ModelId=3C5AA09E015F
	FCOPtr fco;
	//##ModelId=3C5AA09E0169
	CMgaProject *mgaproject;  // Holds no reference
	//##ModelId=3C5AA09E017D
	CComBSTR(regprefix);
	//##ModelId=3C5AA09E0191
	CComBSTR(aspname);
};



#define PPOOL_HASHSIZE 4
#define ppool_hash(x) ((x)%PPOOL_HASHSIZE)


//##ModelId=3C5AA09E01E0
class partpool {
	//##ModelId=3C5AA09E01EB
	CMgaPart::hashobp pool[PPOOL_HASHSIZE];
public:
	//##ModelId=3C5AA09E01FE
	partpool() { 
		int i; 
		for(i = 0; i < PPOOL_HASHSIZE;i++) pool[i] = NULL;
	}

	//##ModelId=3C5AA09E01FF
	~partpool() {
		int i; 
		for(i = 0; i < PPOOL_HASHSIZE;i++) ASSERT(pool[i] == NULL);
	}

	// Throws (allocates)!!!!
	//##ModelId=3C5AA09E0208
	CComPtr<IMgaPart> getpoolobj(metaref_type mref, FCO *o, CMgaProject *pr) {
		CMgaPart::hashobp &k = pool[ppool_hash(mref)], *kk;
		for(kk = &k; *kk != NULL; kk = &((*kk)->next)) {
			if((*kk)->mref == mref) {
				return (*kk);
			}
		}
		CComPtr<CMgaPart > s;
		CreateComObject(s);
		s->prevptr = &k;				// Insert to the front
		s->next = k;
		if(k) k->prevptr = &(s->next);
		k = s;

		s->Initialize(mref, o, pr);  
		return s;
	}
};

#endif //__MGAATTRIBUTE_H_
