#!/usr/bin/python
# Copyright (c) 2004 ISIS, Vanderbilt Univeristy 
#
# Authors: Peter Volgyesi, Gyorgy Balogh
#
# TODO: Create labels in CVS before every release !
""" GME Build System

This is the main (initial) module of the build system.
It loads all the modules in the components subdirectory, and
executes them in the same order as they are listed in components.__all__

It also processes command line parameters and figures out the root
of the source tree, if it was not specified explicitly.

"""

import params, tools, components, check
from components import *

def buildAll():
	for comp in components.__all__:
		exec comp + ".build()"

# main entry point
try:	
	params.setDefaultParams()
	check.checkAll()
	buildAll()	
	
	print "Building process has finished successfully."
except:
	print "Error details:"
	raise
	
