#include "stdafx.h"
#include "logger.h"

#include "string"
#include "algorithm"

#include "globals.h"
extern Globals global_vars;

bool existsFile( const char * src_name)
{
	std::ifstream input_file( src_name, std::ios_base::in);
	if ( !input_file.is_open())
		return false;

	input_file.close();
	return true;
}

int makeFileCopy( const char * src_name, const char * dst_name)
{
	char buff[4096];

	std::ifstream input_file( src_name, std::ios_base::in);
	std::ofstream output_file( dst_name, std::ios_base::out);
	if ( !input_file.is_open())
		return 2;
	if ( !output_file.is_open())
		return 3;

	while ( !input_file.eof())
	{
		input_file.read( buff, 4096);
		output_file.write( buff, input_file.gcount());
	}

	input_file.close();
	output_file.close();
	return 1;
}

std::string shortFileName( const std::string& long_name)
{
	int pos = long_name.rfind( '\\');
	if ( pos != std::string::npos)
	{
		std::string short_name;
		if ( pos + 1 < long_name.length())
			short_name = long_name.substr( pos + 1);
		else
			short_name = "insert_your_specialized_header_filename_here.h";

		return short_name;
	}

	return long_name;
}

std::string cutExtension( const std::string& filename)
{
	int p = filename.rfind( ".");
	if ( p != std::string::npos)
		return filename.substr( 0, p);

	return filename;
}

std::string capitalizeString( const std::string& name)
{
	std::string capitalized_name = name;
	std::transform( capitalized_name.begin(), capitalized_name.end(), capitalized_name.begin(), toupper);
	return capitalized_name;
}
